﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class StickScript : MonoBehaviour
{
    
    public ParticleScript A,B; // the two particles this rod is connecting
    float lenght; // the distance they but be from each other

    // Start is called before the first frame update
    void Start()
    {
        lenght = Vector3.Distance( A.transform.position , B.transform.position );
    }

    public void EnforceMyPositionalConstraint(){
        Vector3 aToB = B.pNow - A.pNow;
        float distAB = aToB.magnitude;
        float k = (distAB - lenght); // how both particles must be moved to enforce the constraints
        A.pNow += aToB * (k * (B.mass)/(A.mass+B.mass) / distAB);
        B.pNow -= aToB * (k * (A.mass)/(A.mass+B.mass) / distAB);
    }

    void FixedUpdate(){
        //EnforceMyPositionalConstraint(); // (moved in the global script)
    }
    
    void Update()
    {
        // change the transform (used by the graphics)
        // so that this sticks appear to be connecting the two speheres
        Vector3 aToB = B.pNow - A.pNow;
        float distAB = aToB.magnitude;
        transform.localPosition = Vector3.Lerp(A.pNow,B.pNow,0.5f);
        transform.localRotation = Quaternion.FromToRotation(Vector3.up,aToB);
        transform.localScale = new Vector3(0.07f,distAB/2,0.07f);
    }
}
